{                            MatSInt . Lib

   Bibliothque manipulant des matrices dont les coefficients sont des
    entiers du type ShortInt

   Drive de Matint.lib  ,  ddie   Genetik.pas
   NB : ncessite la bibliothque COURTOIS.LIB
   Christophe Courtois novembre 1993

   SOMMAIRE :
      Const Matmax,DebMat
      Type  MatSInt
	les matrices sont donc des tableaux d'Integer , et il faudra
	prciser leur dimension ,avec les variables notes ici p et q
	(p lignes , q colonnes=vecteurs)

      InitMatSInt(p,q : Integer ; var A : MatSInt)
      MatUniteSInt (id)
      MatHasardSInt(p,q,param1,param2 , var A)
      TransposeMatSInt(var p,q : integer ; var A : MatSInt)
      EchgeMatSInt(p,q : Int , var A,B : MatInt)
      AddScalMatSInt(p,q,r, var A : MatInt)
      MulScalMatSInt (id)
      AddMatSInt(p,q,A,B, Var C)
      MulMatSInt (p,q ;A,B ; var C)
      AfficheMatSInt(x,y,p,q,t = nb caractres nombres , A)
									  }

CONST Matmax = 15 ;      { taille maxi des matrices : Matmax * Matmax }
      DebMat = 0  ;      { les indices commencent  0 ; en cas de
				 ncessit,passer  1 et recompiler }

TYPE MatSInt  = ARRAY[0..Matmax,0..MatMax] OF ShortInt ;

PROCEDURE InitMatSInt(p,q : Integer ; Var A : MatSInt ) ;
  {  Met  0 tous les coefficients de A }
  Var i,j : Integer ;
  Begin
    For i:=DebMat to p do
      For j:=DebMat to q do
	A[i,j]:=0
  End ;

PROCEDURE MatUniteSInt(p,q : Integer ; Var A : MatSInt) ;
  { A:= matrice unit , ne marche vraiment que sur des carres (p=q)}
  Var i,j : Integer ;
  Begin
    InitMatSInt(p,q,A) ;
    For i:=DebMat to p do
      A[i,i]:=1
  End ;

PROCEDURE MatHasardSInt(p,q : Integer ; param1,param2 : ShortInt ; Var A : MatSInt) ;
  { Cre une matrice avec des coefficients alatoires compris entre
    param1 et param2 (cf Random() pour les valeurs de param)}
  Var i,j : Integer ;
  Begin
    If param1>param2 Then          {param 1 doit tre le plus petit}
      EchgeSInt(param1,param2);
    For i:=DebMat to p do
      For j:=DebMat to q do
	A[i,j]:=Random(param2-param1)+param1
  End ;

PROCEDURE TransposeMatSInt(Var p,q : Integer ; Var A : MatSInt );
  {transpose la matrice A ; n'change pas les valeurs de p et q }
  Var i,j : Integer ;
      X   : MatSInt ;
  Begin
    InitMatSInt(q,p,X) ;
    For i:=DebMat to p do
      For j:=DebMat to q do
	X[j,i]:=A[i,j] ;
    A:=X
  End ;

PROCEDURE EchgeLigneMatSInt(p,q,k,l : Integer ; Var A : MatSInt) ;
  { Echange les lignes k et l de la matrice }
  VAR j   : Integer ;
      x   : ShortInt ;
  Begin
    For j:=DebMat to q do
     Begin
       x:=A[k,j] ; A[k,j]:=A[l,j] ; A[l,j]:=x
     End
  End ;

PROCEDURE EchgeColMatSInt(p,q,k,l : Integer ; Var A : MatSInt) ;
  {Echange les colonnes k et l de la matrice}
  Var i,x : Integer ;
  Begin
    For i:=DebMat to p do
      Begin
	x:=A[i,k] ; A[i,k]:=A[i,l] ; A[i,l]:=x
      End
  End ;

PROCEDURE EchgeMatSInt(p,q : Integer ; Var A,B : MatSInt) ;
  {Echange les deux matrices (de mme taille) A et B}
  Var X : MatSInt ;
  Begin
   X:=A ;
   A:=B ;
   B:=X ;
  End ;

PROCEDURE AddScalMatSInt(p,q,r : Integer ; Var A : MatSInt ) ;
  {Additionne r  tous les coeffs de A }
  Var i,j : Integer ;
  Begin
    For i:=DebMat to p do
      For j:=DebMat to q do
	A[i,j]:=r+A[i,j]
  End ;

PROCEDURE MulScalMatSInt(p,q,r : Integer ; Var A : MatSInt) ;
  {multiplie tous les coeffs de A par l'entier r}
  Var i,j : Integer ;
  Begin
    For i:=DebMat to p do
      For j:=DebMat to q do
	A[i,j]:=r*A[i,j]
  End ;

PROCEDURE AddMatSInt(p,q : Integer ; A,B : MatSInt ; Var C : MatSInt );
  { C=A+B , tous de taille (p,q) }
  Var i,j : Integer ;
  Begin
    For i:=DebMat to p do
      For j:=DebMat to q do
	C[i,j]:=A[i,j]+B[i,j]
  End ;

PROCEDURE MulMatSInt(p,q,r : Integer ; A,B : MatSInt ; Var C : MatSInt );
  { C:= A*B , avec A (p,q) B(q,r) et C(p,r) }
  Var i,j,k : Integer ;
  Begin
    InitMatSInt(p,r,C) ;
    For i:=DebMat to p do
      For j:=DebMat to r do
	For k:=DebMat to q do
	  C[i,j]:=C[i,j] + A[i,k]*B[k,j]
  End ;

PROCEDURE AfficheMatSInt(x,y,p,q,t : Integer ; A : MatSInt );
  { Affiche la matrice A aux coordonnes cran x,y
    t est la taille maximum occupe par les chiffres }
  Var i,j : Integer ;
  Begin
    Gotoxy(x,y) ;
    Write(#218) ;
    For i:=DebMat to q do
      For j:=1 to t do
	Write(' ') ;
    Write (#191) ;
    For i:=DebMat to p do
      Begin
	Inc(y) ;
	Gotoxy(x,y) ;
	Write(#179) ;
	For j:=DebMat to q do
	  Write(A[i,j]:t) ;
	Write(#179)
      End ;
    Inc(y) ;
    Gotoxy(x,y) ;
    Write(#192) ;
    For i:=DebMat to q do
      For j:=1 to t do
	Write(' ') ;
    Write(#217)
  End ;



