{ Bibliothque manipulant des matrices dont les coefficients sont des
    entiers du type Integer

     Christophe Courtois novembre 1993

   NB : ncessite la bibliothque COURTOIS.LIB

     SOMMAIRE :
      Const Matmax,DebMat
      Type  VecteurInt,MatInt
	les matrices sont donc des tableaux d'Integer , et il faudra
	prciser leur dimension ,avec les variables notes ici p et q
	(p lignes , q colonnes=vecteurs)

      InitMatInt(p,q : Integer ; var A : MatInt)
      MatUniteInt (id)
      MatHasardInt(p,q,param , var A)
      TransposeMatInt(var p,q : integer ; var A : MatInt)
      EchgeMatInt(p,q : Int , var A,B : MatInt)
      AddScalMatInt(p,q,r, var A : MatInt)
      MulScalMatInt (id)
      AddMatInt(p,q,A,B, Var C)
      MulMatInt (p,q ;A,B ; var C)
      AfficheMatInt(x,y,p,q,t = nb caractres nombres , A)
									  }


CONST Matmax = 10 ;      { taille maxi des matrices : Matmax * Matmax }
      DebMat = 0  ;      { les indices commencent  0 ; en cas de
				 ncessit,passer  1 et recompiler }
TYPE VectInt = ARRAY[0..Matmax] OF Integer ;
     MatInt  = ARRAY[0..Matmax] OF VectInt ;

PROCEDURE InitMatInt(p,q : Integer ; Var A : MatInt ) ;
  {  Met  0 tous les coefficients de A }
  Var i,j : Integer ;
  Begin
    For i:=DebMat to p do
      For j:=DebMat to q do
	A[i,j]:=0
  End ;

PROCEDURE MatUniteInt(p,q : Integer ; Var A : MatInt) ;
  { A:= matrice unit , ne marche vraiment que sur des carres (p=q)}
  Var i,j : Integer ;
  Begin
    InitMatInt(p,q,A) ;
    For i:=DebMat to p do
      A[i,i]:=1
  End ;

PROCEDURE MatHasardInt(p,q,param : Integer ; Var A : MatInt) ;
  { Cre une matrice avec des coefficients alatoires compris entre
    0 et param (cf Random() pour les valeurs de param)}
  Var i,j : Integer ;
  Begin
    For i:=DebMat to p do
      For j:=DebMat to q do
	A[i,j]:=Random(param)
  End ;

PROCEDURE TransposeMatInt(Var p,q : Integer ; Var A : MatInt );
  {transpose la matrice A ; n'change pas les valeurs de p et q }
  Var i,j : Integer ;
      X   : MatInt ;
  Begin
    InitMatInt(q,p,X) ;
    For i:=DebMat to p do
      For j:=DebMat to q do
	X[j,i]:=A[i,j] ;
    A:=X
  End ;

PROCEDURE EchgeLigneMatInt(p,q,k,l : Integer ; Var A : MatInt) ;
  { Echange les lignes k et l de la matrice }
  VAR j,x : Integer ;
  Begin
    For j:=DebMat to q do
     Begin
       x:=A[k,j] ; A[k,j]:=A[l,j] ; A[l,j]:=x
     End
  End ;

PROCEDURE EchgeColMatInt(p,q,k,l : Integer ; Var A : MatInt) ;
  {Echange les colonnes k et l de la matrice}
  Var i,x : Integer ;
  Begin
    For i:=DebMat to p do
      Begin
	x:=A[i,k] ; A[i,k]:=A[i,l] ; A[i,l]:=x
      End
  End ;

PROCEDURE EchgeMatInt(p,q : Integer ; Var A,B : MatInt) ;
  {Echange les deux matrices (de mme taille) A et B}
  Var X : MatInt ;
  Begin
   X:=A ;
   A:=B ;
   B:=X ;
  End ;

PROCEDURE AddScalMatInt(p,q,r : Integer ; Var A : MatInt ) ;
  {Additionne r  tous les coeffs de A }
  Var i,j : Integer ;
  Begin
    For i:=DebMat to p do
      For j:=DebMat to q do
	A[i,j]:=r+A[i,j]
  End ;

PROCEDURE MulScalMatInt(p,q,r : Integer ; Var A : MatInt) ;
  {multiplie tous les coeffs de A par l'entier r}
  Var i,j : Integer ;
  Begin
    For i:=DebMat to p do
      For j:=DebMat to q do
	A[i,j]:=r*A[i,j]
  End ;

PROCEDURE AddMatInt(p,q : Integer ; A,B : MatInt ; Var C : MatInt );
  { C=A+B , tous de taille (p,q) }
  Var i,j : Integer ;
  Begin
    For i:=DebMat to p do
      For j:=DebMat to q do
	C[i,j]:=A[i,j]+B[i,j]
  End ;

PROCEDURE MulMatInt(p,q,r : Integer ; A,B : MatInt ; Var C : MatInt );
  { C:= A*B , avec A (p,q) B(q,r) et C(p,r) }
  Var i,j,k : Integer ;
  Begin
    InitMatInt(p,r,C) ;
    For i:=DebMat to p do
      For j:=DebMat to r do
	For k:=DebMat to q do
	  C[i,j]:=C[i,j] + A[i,k]*B[k,j]
  End ;

PROCEDURE AfficheMatInt(x,y,p,q,t : Integer ; A : MatInt );
  { Affiche la matrice A aux coordonnes cran x,y
    t est la taille maximum occupe par les chiffres }
  Var i,j : Integer ;
  Begin
    Gotoxy(x,y) ;
    Write(#218) ;
    For i:=DebMat to q do
      For j:=1 to t do
	Write(' ') ;
    Write (#191) ;
    For i:=DebMat to p do
      Begin
	Inc(y) ;
	Gotoxy(x,y) ;
	Write(#179) ;
	For j:=DebMat to q do
	  Write(A[i,j]:t) ;
	Write(#179)
      End ;
    Inc(y) ;
    Gotoxy(x,y) ;
    Write(#192) ;
    For i:=DebMat to q do
      For j:=1 to t do
	Write(' ') ;
    Write(#217)
  End ;



